﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace $safeprojectname$
{
    public sealed class SettingsCacheManager
    {
        private readonly List<KeyValuePair<string, string>> _cachedList;
        public SettingsCacheManager()
        {
            _cachedList = new List<KeyValuePair<string, string>>();
        }

        public int CacheCount
        {
            get
            {
                if (_cachedList != null)
                    return _cachedList.Count;
                else
                    return 0;
            }
        }

        public KeyValuePair<string, string> AddToCache(KeyValuePair<string, string> keypair)
        {
            if (GetKeyValue(keypair.Key) == null)
                _cachedList.Add(keypair);
            else
                ReplaceKeyPair(keypair.Key, keypair.Value);
            return keypair;
        }
        public KeyValuePair<string, string> AddToCache(string key, string value)
        {
            KeyValuePair<string, string> keypair = new KeyValuePair<string, string>(key, value);
            if (GetKeyValue(keypair.Key) == null)
                return AddToCache(keypair);
            else
            {
                ReplaceKeyPair(keypair.Key, keypair.Value);
                return GetKeyPair(keypair.Key);
            }
        }

        public bool RemoveFromCache(string key)
        {
            _cachedList.Remove(_cachedList.Find(w => w.Key == key));
            return true;
        }

        public bool ReplaceKeyPair(string key, string value)
        {
            KeyValuePair<string, string> pair = new KeyValuePair<string, string>(key, value);
            RemoveFromCache(key);
            AddToCache(pair);
            return true;
        }

        public KeyValuePair<string, string> GetKeyPair(string key)
        {
            var res = _cachedList.Find(w => w.Key == key);
            return res;
        }

        public string GetKeyValue(string key)
        {
            var res = _cachedList.Find(w => w.Key == key).Value;
            return res;
        }


        public List<KeyValuePair<string, string>> GetKeyValues(string[] keys)
        {
            IQueryable<KeyValuePair<string, string>> query = _cachedList.AsQueryable();

            query = query.Where(w => keys.Contains(w.Key));

            var res = query.ToList();
            return res;
        }

        public bool IsKeyAviable(string key)
        {
            return _cachedList.Find(w => w.Key == key).Value != null;
        }


        public void ClearCache()
        {
            _cachedList.Clear();
        }


        public override string ToString()
        {
            return $"Settingscache has {CacheCount} items";
        }
    }
}
