﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Threading.Tasks;

namespace $safeprojectname$
{
    public interface IGenericRepository<T>
    {
        object Context { get; set; }
        IQueryable<T> GetAll(bool tracking = false);
        Task<List<T>> GetAsync(IQueryable<T> query);

        T Find(int id);
        Task<T> FindAsync(int id);
        IQueryable<T> FindBy(Expression<Func<T, bool>> predicate, bool tracking = false);
        Task<T> FindByAsync(Expression<Func<T, bool>> predicate, bool tracking = false);
        Task<T> FindByAsync(IQueryable<T> query);

        void Add(T entity);
        void Delete(T entity);
        void Edit(T entity);
        void Attach(T entity);
        void Detach(T entity);

        bool ReferenceLoaded(T entity, string prop);
        bool CollectionLoaded(T entity, string prop);

        void LoadReference(T entity, string prop);
        void LoadCollection(T entity, string prop);

        IQueryable<T> SetTracking(bool tracking, IQueryable<T> query);

        int CountAll(bool includeDeleted = false);
        Task<int> CountAsync(bool includeDeleted = false);

        bool Any(bool includeDeleted = false);
        Task<bool> AnyAsync(bool includeDeleted = false);

        int Save();
        Task<int> SaveAsync();
    }
}
