﻿using System.Windows;
using System.Windows.Controls;

namespace $safeprojectname$
{
    /// <summary>
    /// die angehängte NoFrameHistory-Eigenschaft zum Erstellen eines <see cref = "Frame" />, das keine Navigation anzeigt
    /// und lässt den Navigationsverlauf leer
    /// </ summary>
    public class NoFrameHistory : AttachedPropertyBase<NoFrameHistory, bool>
    {
        public override void OnValueChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            var frame = (sender as Frame);
            frame.NavigationUIVisibility = System.Windows.Navigation.NavigationUIVisibility.Hidden;
            frame.Navigated += (ss, ee) => ((Frame)sender).NavigationService.RemoveBackEntry();
        }
    }
}
