﻿using System.Windows;
using System.Windows.Controls;

namespace $safeprojectname$
{
    /// <summary>
    /// eine Attached Property um den Rand Abstand der Kindelemente eines Panel gleich zu setzen
    /// </summary>
    public class PanelChildMarginProperty : AttachedPropertyBase<PanelChildMarginProperty, string>
    {
        public override void OnValueChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            var panel = (sender as Panel);
            panel.Loaded += (s, ee) =>
            {
                foreach (var child in panel.Children)
                    (child as FrameworkElement).Margin = (Thickness)(new ThicknessConverter().ConvertFromString(e.NewValue as string));
            };
        }
    }
}
