﻿using System.Windows;
using System.Windows.Controls;

namespace $safeprojectname$
{
    #region MonitorPassword
    /// <summary>
    /// die angehängte MonitorPassword-Eigenschaft für ein <see cref = "PasswordBox" />
    /// </ summary>
    public class MonitorPasswordProperty : AttachedPropertyBase<MonitorPasswordProperty, bool>
    {
        public override void OnValueChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            var passwordBox = sender as PasswordBox;

            if (passwordBox == null) return;

            passwordBox.PasswordChanged -= PasswordBox_PasswordChanged;

            if ((bool)e.NewValue)
            {
                HasTextProperty.SetValue(passwordBox);
                passwordBox.PasswordChanged += PasswordBox_PasswordChanged;
            }
        }

        /// <summary>
        /// wird ausgelöst, wenn sich der <see cref = "PasswordBox" /> Kennwortwert ändert
        /// </ summary>
        /// <param name = "sender"> </ param>
        /// <param name = "e"> </ param>
        private void PasswordBox_PasswordChanged(object sender, RoutedEventArgs e)
        {
            HasTextProperty.SetValue((PasswordBox)sender);
        }
    }

    /// <summary>
    /// die angehängte HasText-Eigenschaft für ein <see cref = "PasswordBox" />
    /// </ summary>
    public class HasTextProperty : AttachedPropertyBase<HasTextProperty, bool>
    {
        /// <summary>
        /// Setzt die HasText-Eigenschaft basierend darauf, ob der Aufrufer <see cref = "PasswordBox" /> einen beliebigen Text hat
        /// </ summary>
        /// <param name = "sender"> </ param>
        public static void SetValue(DependencyObject sender)
        {
            SetValue(sender, ((PasswordBox)sender).SecurePassword.Length > 0);
        }
    }
    #endregion
}
