﻿using System;
using System.Globalization;
using System.Windows;

namespace $safeprojectname$
{
    public class EnumToBoolConverter : ValueConverterBase<EnumToBoolConverter>
    {
        public override object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string paramString = parameter.ToString();
            if (paramString == null)
                return DependencyProperty.UnsetValue;
            if (!Enum.IsDefined(value.GetType(), value))
                return DependencyProperty.UnsetValue;
            object paramValue = Enum.Parse(value.GetType(), paramString);
            return paramValue.Equals(value);

        }

        public override object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string paramString = parameter.ToString();
            if (paramString == null)
                return DependencyProperty.UnsetValue;

            return Enum.Parse(targetType, paramString);

        }
    }
}
